# About this archive

This archive includes all supporting datasets for the accepted Journal
of Functional Programming paper "Transparent Fault Tolerance for
Scalable Functional Computation".

The contents are:

1. A SPIN model of HdpH-RS scheduling.

   The hdph_scheduler.pml file is a Promela file corresponding to
   section 5 of the paper, "Validating Reliable Work Stealing". It can
   be verified with the SPIN model checker, which can be downloaded
   for free from http://spinroot.com .

2. Scripts for generating graphs.

   The files plot-runtime.R, plot-scaleup.R and plot-timeoffailure.R
   are R scripts for plotting runtime results presented in section 7,
   "Evaluation".

3. Scripts for generating runtime results.

   The files with filename pattern run-*.sh ,
   e.g. run-mandel-nodes-scaleup.sh , are scripts for executing the
   four benchmarks SumEuler, Summatory Liouville, N-Queens and
   Mandelbrot on the Beowulf and HPC clusters described in section 7.

4. Runtime and failure results.

   The files with filename patterns results-*.Rdata and results-*.data
   are the raw runtime and failure results plotted in section 7 and
   tabled in appendix B.

3. Benchmark source code.

   The benchmark Haskell source code files for SumEuler, Summatory
   Liouville, N-Queens and Mandelbrot are files sumeuler.hs
   summatory-liouville.hs queens.hs mandel.hs respectively. They can
   be compiled and executed with GHC once the HdpH-RS Haskell library
   is installed. They are freely available:

   - GHC https://www.haskell.org/ghc
   - HdpH-RS https://github.com/robstewart57/hdph-rs
